.386
.model flat,stdcall
option casemap:none

include     \masm32\include\windows.inc
include     \masm32\include\user32.inc
include     \masm32\include\kernel32.inc
include     \masm32\include\gdi32.inc

includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\gdi32.lib
includelib  Bitmap.lib

LoadBitmapfromDLL   PROTO :DWORD
WinMain             PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data
ClassName   db "BitmapClass",0
AppName     db "Bitmap from DLL",0

.data?
hInstance   HINSTANCE ?
CommandLine LPSTR ?
hBitmap     dd ?

.code
start:
    invoke  GetModuleHandle, NULL
    mov     hInstance,eax
    invoke  GetCommandLine
    mov     CommandLine,eax
    invoke  WinMain,hInstance,NULL,eax, SW_SHOWDEFAULT
    invoke  ExitProcess,eax

WinMain PROC hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    LOCAL hwnd:HWND
    mov     wc.cbSize,SIZEOF WNDCLASSEX
    mov     wc.style, CS_HREDRAW or CS_VREDRAW
    mov     wc.lpfnWndProc, OFFSET WndProc
    mov     wc.cbClsExtra,NULL
    mov     wc.cbWndExtra,NULL
    push    hInstance
    pop     wc.hInstance
    mov     wc.hbrBackground,COLOR_WINDOW+1
    mov     wc.lpszMenuName,NULL
    mov     wc.lpszClassName,OFFSET ClassName
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassEx, ADDR wc
    INVOKE  CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
            WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
            CW_USEDEFAULT,290,90,NULL,NULL,\
            hInst,NULL
    mov     hwnd,eax
    invoke  ShowWindow, hwnd,SW_SHOWNORMAL
    invoke  UpdateWindow, hwnd
    .WHILE  TRUE
        invoke  GetMessage, ADDR msg,NULL,0,0
        .break  .if (!eax)
        invoke  TranslateMessage, ADDR msg
        invoke  DispatchMessage, ADDR msg
    .ENDW
    mov     eax,msg.wParam
    ret
WinMain ENDP

WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

   LOCAL ps:PAINTSTRUCT
   LOCAL hdc:HDC
   LOCAL hMemDC:HDC

   .IF uMsg==WM_CREATE
        invoke  LoadBitmapfromDLL,10000
        mov     hBitmap,eax	
          
   .ELSEIF uMsg==WM_PAINT
        invoke  BeginPaint,hWnd,ADDR ps
        mov     hdc,eax
        invoke  CreateCompatibleDC,eax
        mov     hMemDC,eax
        invoke  SelectObject,eax,hBitmap
        invoke  BitBlt,hdc,0,0,250,40,hMemDC,0,0,SRCCOPY
        invoke  DeleteDC,hMemDC
        invoke  EndPaint,hWnd,ADDR ps

    .ELSEIF uMsg==WM_DESTROY
        invoke  DeleteObject,hBitmap
        invoke  PostQuitMessage,NULL

    .ELSE
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam		
        ret

    .ENDIF
    
    xor     eax,eax
    ret

WndProc ENDP

END start